> For the complete documentation index, see [llms.txt](https://developer.tryreferd.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.tryreferd.com/installing-referd/referd-for-android/send-user-events-to-referd.md).

# Track Referd Events

Start sending your users' **events** on your app to **Referd**, along with any **metadata** that describes the event. Depending on your **Referd** programs configuration, the user can be rewarded based on the sent events.

Tracked **events** can be app events or server side events depending on how you would like to design your programs. App **events** can be sent via the available SDK interface and server-sdie **events** can be sent to **Referd** via the [Track Events API](/api-reference/api-reference/event.md).

Every `Track Event` call records a single user action. We call these “**events**”. We recommend that you make your event names human-readable, so that everyone can know what they mean instantly.

**Event metadata** are extra pieces of information you can tie to events you track. They can be anything that will be useful while designing your program.

To send Player events from your app to **Referd**, you can use the **`sendEvent`** method as shown below.

<table data-header-hidden><thead><tr><th width="220">Parameter</th><th width="110">Type</th><th width="115">Required</th><th>Description</th></tr></thead><tbody><tr><td>Parameter</td><td>Type</td><td>Required</td><td>Description</td></tr><tr><td><code>Event</code></td><td><strong>Event Object</strong></td><td><strong>Yes</strong></td><td>Event body that is being sent to Referd's dashboard.</td></tr><tr><td><code>CallBack</code></td><td><strong>function</strong></td><td><strong>No</strong></td><td>Callback is used for providing the developer with the status of the request as a boolean whether it succeeded or not or with an error if any.</td></tr></tbody></table>

**`SendEvent`** interface sends an **`Event`**&#x6F;bject to **Referd**. Where the **`Event`**&#x6F;bject is a wrapper holding a single or list of events. To add an event you should use the **`sendEvent`** method and pass to it th&#x65;**`Event`**&#x6F;bject you have created.

***SendEvent*** is a builder class that helps in creation of the **Event** with the common attributes mentioned below, all of these attributes are **optional** to use.

<table><thead><tr><th width="207">Method</th><th>Parameter Name</th><th>Type</th></tr></thead><tbody><tr><td>AddUniquePlayerId</td><td>UniquePlayerId</td><td>String</td></tr><tr><td>AddEventName</td><td>eventName</td><td>string</td></tr><tr><td>AddEmail</td><td>email</td><td>string</td></tr><tr><td>AddMobile</td><td>mobileNumber</td><td>string</td></tr><tr><td>AddeventMetaData</td><td>(key, value)</td><td>(string, Object)</td></tr></tbody></table>

{% tabs %}
{% tab title="Java" %}

```java
Event event = new Event.Builder()
        .AddUniquePlayerId("player123")
        .AddEventName("purchase_completed")
        .AddEmail("jack@domain.com")
        .AddMobile("0123456789")
        .AddEventMetaData("purchase_price", 19.99)
        .build();
```

{% endtab %}

{% tab title="Kotlin" %}

```kotlin
val event = Event.Builder()
    .AddUniquePlayerId("player123")
    .AddEventName("purchase_completed")
    .AddEmail("jack@domain.com")
    .AddMobile("0123456789")
    .AddEventMetaData("purchase_price", 19.99)
    .build()
```

{% endtab %}
{% endtabs %}

### Send the Event

Using the previously created GameballApp instance or by creating a new one, call the ***SendEvent()*** method as shown below.

{% tabs %}
{% tab title="Java" %}

```java
gameballApp.sendEvent(event, new Callback<Boolean>() {
    @Override
    public void onSuccess(Boolean aBoolean) {
        // TODO Handle on success result
    }

    @Override
    public void onError(Throwable e) {
        // TODO Handle on failure result
    }
});
```

{% endtab %}

{% tab title="Kotlin" %}

```kotlin
gameballApp.sendEvent(event, object : Callback<Boolean?> {
    override fun onSuccess(aBoolean: Boolean?) {
        // TODO Handle on success result
    }

    override fun onError(e: Throwable) {
        // TODO Handle on failure result
    }
})
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developer.tryreferd.com/installing-referd/referd-for-android/send-user-events-to-referd.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
